#ifndef TimePixMapListener_h
#define TimePixMapListener_h 1

#include "TimePixPixelMode.h"

#include "lcio.h"
#include "EVENT/LCCollection.h"

// LCCD headers
#include "lccd.h"
//#include "lccd/DBFileHandler.hh"
#include "lccd/IConditionsChangeListener.hh"

namespace tpcconddata{


typedef std::map<TimePixPixelMode::PixelKey, TimePixPixelMode*> TimePixMap;

class TimePixMapListener
{
 public:
  TimePixMapListener( );

  class TimePixModeMapListener: public lccd::IConditionsChangeListener  {
  public:
    TimePixModeMapListener( TimePixMapListener *mapListener );
    void conditionsChanged( LCCollection* col );
  private:
    TimePixMapListener *_mapListener;
  };

  class TimePixStatusMapListener: public lccd::IConditionsChangeListener  {
  public:
    TimePixStatusMapListener(TimePixMapListener *mapListener);
    void conditionsChanged( LCCollection* col );
  private:
    TimePixMapListener *_mapListener;
  };


  friend class TimePixModeMapListener;

  friend class TimePixStatusMapListener;

  TimePixMap* getMap();

  TimePixModeMapListener   *getModeMapListener();
  TimePixStatusMapListener *getStatusMapListener();

  
 private:
  TimePixMap _timePixMap;

  void modeChanged( LCCollection* col );
  void statusChanged( LCCollection* col );

  TimePixModeMapListener   _modeMapListener;
  TimePixStatusMapListener _statusMapListener;

} ;




} //namespace tpcconddata

#endif
