/* TimePixPixelMode.cc
 * $Id$ 
 */

#include "TimePixPixelMode.h"

namespace tpcconddata{

std::string TimePixPixelMode::getRevision(){
    return std::string("$Rev: 957 $");
}


TimePixPixelMode::TimePixPixelMode(int ChipID, int PixelID, int PixelMode, int PixelStatus ){
    setChipID(ChipID);
    setPixelID(PixelID);
    //    setPixelMode(PixelMode);
    setPixelStatusWord( PixelStatus | PixelMode );
}

TimePixPixelMode::~TimePixPixelMode(){ }

int TimePixPixelMode::getChipID() {
    return obj()->getIntVal( 0 ) ;
}

int TimePixPixelMode::getPixelID() {
    return obj()->getIntVal( 1 ) ;
}

int TimePixPixelMode::getPixelMode() {
    return obj()->getIntVal( 2 ) & 0x3 ;
}

int TimePixPixelMode::getPixelStatus() {
    return obj()->getIntVal( 2 ) & 0x30000 ;
}

int TimePixPixelMode::getPixelStatusWord() {
    return obj()->getIntVal( 2 ) ;
}

TimePixPixelMode::PixelKey TimePixPixelMode::getPixelKey() {
    return TimePixPixelMode::PixelKey( obj()->getIntVal( 0 ),  
				       obj()->getIntVal( 1 ) ) ;
}


void TimePixPixelMode::setChipID(int Chip){
    obj()->setIntVal( 0, Chip) ;
}

void TimePixPixelMode::setPixelID(int Pixel){
    obj()->setIntVal( 1, Pixel) ;
}

void TimePixPixelMode::setPixelMode(int Mode){
  obj()->setIntVal( 2, 
		    // everything but the last two bits of the previous value
		    (obj()->getIntVal( 2 ) & ~0x3) |
		    // only the last two bits of the given mode
		    (Mode & 0x3)                       ) ;  
}

void TimePixPixelMode::setPixelStatus(int Status){
  obj()->setIntVal( 2, 
		    // everything but the status bits of the previous value
		    (obj()->getIntVal( 2 ) & ~0x30000) |
		    // only the status bits of the given status
		    (Status & 0x30000)                       ) ;  

}


void TimePixPixelMode::setPixelStatusWord(int StatusWord){
    obj()->setIntVal( 2, StatusWord) ;
}


TimePixPixelMode::PixelKey::PixelKey( int chipid, int pixelid ) {

    ChipID = chipid;
    PixelID = pixelid;

  }




}
