#include "DumpNTracksProcessor.h"

//C++
#include <iostream>
using namespace std;

//LCIO
#include <IMPL/LCCollectionVec.h>
#include <EVENT/Track.h>
#include <EVENT/TrackerHit.h>

using namespace lcio ;
using namespace marlin ;

namespace marlintpc
{

DumpNTracksProcessor aDumpNTracksProcessor;
    
DumpNTracksProcessor::DumpNTracksProcessor(): Processor("DumpNTracksProcessor")
{
    // register steering parameters: name, description, class-variable, default value
    registerInputCollection(    LCIO::TRACK,
				"InputTracks" , 
				"Name of the input tracks collection"  ,
				_inputColName ,
				std::string("TPCSeedTracks") ) ;
    // modify processor description
    _description = "DumpNTracksProcessor: Dump coordinates of hits in tracks" ;
}

void DumpNTracksProcessor::init()
{
    cout << "# eventNr nTracks" << endl;
}

void DumpNTracksProcessor::processRunHeader( LCRunHeader* run)
{
    cout << "# new run " << run->getRunNumber () << endl;
}
    
void DumpNTracksProcessor::processEvent( LCEvent * evt ) 
{ 
    //read input data
//    cout << "Event: " << evt->getEventNumber() << endl;

    // we need a LCCollectionVec to use iterators, as LCCollectios is o not a std::vector
    LCCollectionVec* InputCollection=0;
    try{
	InputCollection = dynamic_cast<LCCollectionVec*>(evt->getCollection( _inputColName )) ;
    }
    catch(DataNotAvailableException &e)
    {
	// no input data
	// just continue ...
	return;
    }


    if( InputCollection != 0 )
    {
	std::cout << evt->getEventNumber() <<"\t" 
		  << InputCollection->getNumberOfElements () << std::endl;
    }
}


}// namespace 
